-- From Natively Compiled T-SQL: The Fastest T-SQL Ever 
-- (C) Copyright  2016 Andrew S Novick.  All rights reserved
-- Use for demo purposes only.
go

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

SET ANSI_PADDING ON
GO
CREATE FUNCTION [dbo].[exp_moving_avg_scalar] (

    @ema_yesterday FLOAT
  , @value_today FLOAT
  , @days INT
  , @smoothing FLOAT = 2.0
 
) RETURNS FLOAT 
AS BEGIN
RETURN CASE WHEN @ema_yesterday IS NULL 
            THEN @value_today
            ELSE (@value_today * (@smoothing/(1.0+@days)))
                   + (@ema_yesterday 
                        * (1.0 - (@smoothing/(1.0+@days)))) 
            END      
END

go
CREATE FUNCTION [dbo].[exp_moving_avg_inline] (

    @ema_yesterday FLOAT
  , @value_today FLOAT
  , @days INT
  , @smoothing FLOAT = 2.0

) RETURNS TABLE 

AS RETURN
SELECT CASE WHEN @ema_yesterday IS NULL 
            THEN @value_today
            ELSE (@value_today * (@smoothing/(1.0+@days)))
                   + (@ema_yesterday 
                        * (1.0 - (@smoothing/(1.0+@days)))) 
            END      
       as ema_today 
GO

DROP FUNCTION [dbo].[exp_moving_avg_scalar_nc] 
GO

CREATE FUNCTION [dbo].[exp_moving_avg_scalar_nc] (

    @ema_yesterday FLOAT
  , @value_today FLOAT
  , @days INT
  , @smoothing FLOAT = 2.0
 
) RETURNS FLOAT 
WITH NATIVE_COMPILATION, SCHEMABINDING, CALLED ON NULL INPUT
AS BEGIN ATOMIC WITH (TRANSACTION ISOLATION LEVEL=SNAPSHOT,language = N'English')

IF @ema_yesterday IS NULL RETURN @value_today

RETURN (@value_today * (@smoothing/(1.0+@days)))
                   + (@ema_yesterday 
                        * (1.0 - (@smoothing/(1.0+@days)))) 
						          
END


						
CREATE TYPE EAV_tt_inmem  AS TABLE (
	[entity_id] int NOT NULL,
	attribute_id smallint NOT NULL ,
	value VARCHAR(256) NOT NULL,
    INDEX IX_entity_attribute NONCLUSTERED ([entity_id], attribute_id)
) WITH (MEMORY_OPTIMIZED = ON)
go


create function x (
	@i int 
	) returns dbo.EAV_tt_inmem 
	with NATIVE_COMPILATION, SCHEMABINDING, CALLED ON NULL INPUT

	AS BEGIN ATOMIC WITH (TRANSACTION ISOLATION LEVEL=SNAPSHOT,language = N'English')


DECLARE @eav_temp EAV_tt_inmem;

insert @eav_temp(entity_id, attribute_id, value) values (1,2,'abcd')

RETURN @eav_temp
END
